//
//	ByteList.h
//
//	Created on: Dec 30, 2019
//      Author: vagner
//

#pragma once

#include <string>
#include <list>

#include "vdef.h"

#define BSIZE 4096

namespace vCommon
{

	class ByteList
	{
	public:

		//	ctor
		ByteList ( ) : buf ( ) { }

		//	dtor
		virtual ~ByteList ( ) { buf.clear ( ); }

		//	clear ( )
		void clear ( ) { buf.clear ( ); }

		//	empty ( )
		bool empty ( ) { return buf.empty ( ); }

		//	size ( )
		int size ( ) { return buf.size ( ); }

		//	compare
		bool compare ( byte* buf );

		//	list <= 8
		void push_8 ( byte value );

		//	list <= 16
		void push_16 ( u16 value );

		//	list <= u32
		void push_32 ( u32 value );

		//	list <= string
		void push_string ( std::string& value );

		//	pop_to => list
		void pop_to ( ByteList& dst );

		//	pop to => byte*
		void pop_to ( byte* dst, int bsize );

		//	pop to => byte*
		void pop_to ( byte* dst, int& offset, int bsize );

		//	вычислить CRC16
		u16 crc_16 ( );

		//	вычислить CRC32
		u32 crc_32 ( );

	private:

		//	buf
		std::list<byte> buf;
	};

} /* namespace vCommon */
