#pragma once

#include <vrs.h>
#include <string>
#include <vector>


namespace serial
{
	//-----------------------------------------------------------------------------
	//	ComOptions
	class ComOptions
	{
	public:

		//	 rs-порт.
		std::string port;

		//	Скорость.
		int baud_rate;

		//	количество бит в байте
		serial::bytesize_t bytesize;

		//	контроль четности
		serial::parity_t parity;

		//	количество стоп-бит
		serial::stopbits_t stopbits;

		//	управление обменом
		serial::flowcontrol_t flowcontrol;

		//	def ctor
		ComOptions ( );

		//	ctor
		ComOptions ( const std::string& port, const int baude_rate, const std::string& co );

		//	анализ
		void parse ( const std::string& co );

		//	валидировать
		bool validate ( );
	};

} /* namespace serial */
