//
//	SyncTime.h
//
//	Автор	:	vagner
//	Создан	:	Sep 27, 2019
//

#pragma once

#include <string>

#include <mqSyncClient.h>
#include "ServerTime.h"

namespace vtc
{
	//	состояния синхронизации
	enum class SyncState
	{
		None = 0
		, Server
		, Local
	};

	class SyncTime
	{
	public:

		//	ctor
		SyncTime ( const std::string& Url, const int Port, const std::string& ClientId );

		//	dtor
		~SyncTime ( );

		//	синхронизировать время
		bool Sync ( vMQ::mqClient* outerClient = nullptr );

		//	синхронизировать время с сервером
		bool SrvSync ( vMQ::mqClient* outerClient );

		//	сохранить время
		inline bool SaveTime ( ) { return st->Save ( ); }

		//	состояние
		inline SyncState get_state ( ) { return state; }

	private:

		//	"серверное" время
		ServerTime* st;

		//	MQTT Url
		std::string Url;

		//	MQTT Port
		int Port;

		//	ClientId
		std::string ClientId;

		//	состояние
		SyncState state;

		//	время последней синхронизации
		i64 LastSyncTime;
	};

} /* namespace vtc */
